#include "settings.h"

//////// Settings macros ////////

Uint32 getPrivateProfileLong(char * section, char * key, char * def, char * path)
{
	char buffer[32];

	GetPrivateProfileString(section, key, def, buffer, 32, path);

	return atoi(buffer);
}


//////// Directory settings ////////

directorySettings::directorySettings()
{
	reloadSettings();
}

directorySettings::~directorySettings()
{
	deleteStrings();
}

void directorySettings::deleteStrings()
{
}

void directorySettings::reloadSettings()
{
	deleteStrings();

	// Retrieve path
	char path[532];
	GetCurrentDirectory(520, path);
	strcat(path, "\\");
	strcat(path, INI_NAME);

	// Retrieve settings
	PacketSilenceLimit	 = getPrivateProfileLong("Core", "PacketSilenceLimit", "2000", path);
	MaxReliableInTransit = getPrivateProfileLong("Core", "MaxReliableInTransit", "3", path);
	ChunkSize			 = getPrivateProfileLong("Core", "ChunkSize", "496", path);
	ClusterMode			 = (getPrivateProfileLong("Core", "ClusterMode", "0", path) != 0);
	MaxHosts			 = getPrivateProfileLong("Core", "MaxHosts", "10", path);

	IterationSleepTime = getPrivateProfileLong("CPU", "IterationSleepTime", "15", path);
	SlowIteration	   = getPrivateProfileLong("CPU", "SlowIteration", "300", path);

	SweepTime		= getPrivateProfileLong("Zone", "SweepTime", "500", path);
	DropLimit		= getPrivateProfileLong("Zone", "DropLimit", "10", path);
	ReclaimDelay	= getPrivateProfileLong("Zone", "ReclaimDelay", "24", path) * 1000 * 60 * 60;
	InitialHighPing = getPrivateProfileLong("Zone", "InitialHighPing", "300", path);

	DownloadTime = getPrivateProfileLong("Directory", "DownloadTime", "1", path) * 1000 * 60;
	GetPrivateProfileString("Directory", "StatsFile", "stats.txt", StatsFile, 32, path);
	StatsWriteMinutes = getPrivateProfileLong("Directory", "StatsWriteMinutes", "1", path) * 1000 * 60;

	// Retrieve directories
	char buffer[256];
	Uint32 len, i, o = 0;
	bool found = true;
	TotalHosts = 0;

	len = GetPrivateProfileString("Directory", "IP", "sscentral.ds98.com, sscentral.subspace.net & sscentral.subspace.inet.fi", buffer, 256, path);
	for (i = 0; i < (len + 1); i++)
	{	// The NUL will be interpreted as a comma
		char c = buffer[i];

		if ((c == '.')				   ||
			((c >= '0') && (c <= '9')) ||
			((c >= 'a') && (c <= 'z')) ||
			((c >= 'A') && (c <= 'Z')))
		{
			if (found == false)
			{
				o = i;
				found = true;
			}
		}
		else
		{
			if (found == true)
			{
				buffer[i] = 0;
				TrustedHosts[TotalHosts++] = resolveHostname(buffer + o);
				found = false;
			}
		}
	}
}
